

%  clear all
%  clc


omega1=300;
omega2=300;
omega_c1=omega1;
omega_c2=omega2;

dh1=0.095;
ds1=0.210;
d1=(dh1^2+ds1^2)^0.5;
r1=3*d1/2;
d2=0.557;
r2=4*d2/2;

rho1=1.2;
A1=0.00956;
beta1b=40*pi/180;
beta2b=90*pi/180;
nblades=22;
sigma=1-2/(nblades);
ws=10;
kf=5; 
cp=2064;
kappa=1.3;
T01=293;
%alpha=(cot(beta1b)/(rho1*A1*r1));
alpha=50;
%========================
a0=340;
Vp=1;
% A1=pi*(0.07/2)^2;
Lc=1;
p0=1e5;
kt=0.5;
ut=0.1;
p=1e5;
%========================

mu = 0.9091;

%========================

sim('ParallelCouplingLinearize.mdl')
sys = 'ParallelCouplingLinearize';
load_system(sys);

opspec = operspec('ParallelCouplingLinearize');

op1 = findop('ParallelCouplingLinearize',opspec);

sys1 = linearize('ParallelCouplingLinearize',op1);

%

op2 = findop('ParallelCouplingLinearize',1);

sys2 = linearize('ParallelCouplingLinearize',op2);

op = operspec('ParallelCouplingLinearize');


Ob1 = obsv(sys1);
unob1 = length(sys1.a)-rank(Ob1)
Co1 = ctrb(sys1);
unco1 = length(sys1.a)-rank(Co1)


Ob2 = obsv(sys2);
unob2 = length(sys2.a)-rank(Ob2)
Co2 = ctrb(sys2);
unco2 = length(sys2.a)-rank(Co2)


WW=sim_WW.signals.values;
WW1=sim_WW1.signals.values;
PP=sim_PP.signals.values;
Wt=sim_Wt.signals.values;
time=sim_t.signals.values;
PSI1=sim_PsiB.signals.values;
PSI2=sim_PsiB1.signals.values;

t=length(time);

speed = 14000:500:19000;
w = (0.1:0.1:30);
w2 = 0:0.01:20;

%========================
v = length(speed);
n = length(w);
f = length(w2);

PSII = zeros(n,1);
my1 = zeros(n,1);
Psi=zeros(n,v);
w1=zeros(n,v);

%% ========================
% Building the speedlines

% P_pref(1:t) = Pref;
% WWref(1:t)=Wref;
% WW1ref(1:t)=W1ref;
% WWtot=WW+WW1;
% 
for k=1:v
    omega = speed(k)/60;
    
    for i = 1:n
    
    my1(i) = sigma*(1-cot(beta2b)/(rho1*A1*r1)*w(i)/omega);

    PSII(i) = (1+(my1(i)*r2^2*omega^2 - ((r1^2)/2)*(omega - alpha * w(i))^2 ...
              - kf*w(i)^2)/(cp*T01))^(kappa/(kappa - 1));

    end
    
    Psi(:,k)=PSII;
    w1(:,k)=w;

end

for t=1:f

y1(t) = 0.175*w2(t) + sqrt(0.05-(w2(t)-10)^2);
y2(t) = 0.175*w2(t) - sqrt(0.05-(w2(t)-10)^2);

y3(t) = 0.175*w2(t) + sqrt(0.2-(w2(t)-10)^2);
y4(t) = 0.175*w2(t) - sqrt(0.2-(w2(t)-10)^2);

y5(t) = 0.175*w2(t) + sqrt(0.8-(w2(t)-10)^2);
y6(t) = 0.175*w2(t) - sqrt(0.8-(w2(t)-10)^2);

y7(t) = 0.175*w2(t) + sqrt(2-(w2(t)-10)^2);
y8(t) = 0.175*w2(t) - sqrt(2-(w2(t)-10)^2);

end

plot(WW,PSI1,WW1,PSI2,WW,PP,WW1,PP)
hold on
plot(w2,y1,'k',w2,y2,'k',w2,y3,'k',w2,y4,'k');
hold on
plot(w2,y5,'k',w2,y6,'k',w2,y7,'k',w2,y8,'k');
E1=eig(sys1.a)

E2=eig(sys2.a)

if E1<=0
    
    disp('E1 ok')
    
end

if E2<=0
    
    disp('E2 ok')
    
end




