
% Pref=1.9
% Wref=11
% W1ref=11

% sim('BeginParalell2.mdl')

% sim('ParallelCoupling.mdl')
sim('ParallelCouplingLinearizeHANDINN.mdl')
WW = sim_WW.signals.values;
WW1 = sim_WW1.signals.values;
PP = sim_PP.signals.values;
Wt = sim_Wt.signals.values;
time = sim_t.signals.values;
PSI1 = sim_PsiB.signals.values;
PSI2 = sim_PsiB1.signals.values;
u_v = u_v.signals.values;
u_omega1 = u_omega1.signals.values;
u_omega2 = u_omega2.signals.values;

t=length(time);


%% ========================
% Speed and mass flow vectors

speed = 14000:500:19000;
w = (0.1:0.1:30);
w2 = 0:0.01:20;

%========================
v = length(speed);
n = length(w);
f = length(w2);

PSII = zeros(n,1);
my1 = zeros(n,1);
Psi=zeros(n,v);
w1=zeros(n,v);

%% ========================
% Building the speedlines

P_pref(1:t) = Pref;
WWref(1:t)=Wref;
WW1ref(1:t)=W1ref;
WWtot=WW+WW1;

for k=1:v
    omega = speed(k)/60;
    
    for i = 1:n
    
    my1(i) = sigma*(1-cot(beta2b)/(rho1*A1*r1)*w(i)/omega);

    PSII(i) = (1+(my1(i)*r2^2*omega^2 - ((r1^2)/2)*(omega - alpha * w(i))^2 ...
              - kf*w(i)^2)/(cp*T01))^(kappa/(kappa - 1));

    end
    
    Psi(:,k)=PSII;
    w1(:,k)=w;

end

for t=1:f

y1(t) = 0.175*w2(t) + sqrt(0.05-(w2(t)-10)^2);
y2(t) = 0.175*w2(t) - sqrt(0.05-(w2(t)-10)^2);

y3(t) = 0.175*w2(t) + sqrt(0.2-(w2(t)-10)^2);
y4(t) = 0.175*w2(t) - sqrt(0.2-(w2(t)-10)^2);

y5(t) = 0.175*w2(t) + sqrt(0.8-(w2(t)-10)^2);
y6(t) = 0.175*w2(t) - sqrt(0.8-(w2(t)-10)^2);

y7(t) = 0.175*w2(t) + sqrt(2-(w2(t)-10)^2);
y8(t) = 0.175*w2(t) - sqrt(2-(w2(t)-10)^2);

%----------------------------------

y11(t) = 0.13*w2(t) + sqrt(0.05-(w2(t)-13)^2);
y21(t) = 0.13*w2(t) - sqrt(0.05-(w2(t)-13)^2);

y31(t) = 0.13*w2(t) + sqrt(0.2-(w2(t)-13)^2);
y41(t) = 0.13*w2(t) - sqrt(0.2-(w2(t)-13)^2);

y51(t) = 0.13*w2(t) + sqrt(0.8-(w2(t)-13)^2);
y61(t) = 0.13*w2(t) - sqrt(0.8-(w2(t)-13)^2);

y71(t) = 0.13*w2(t) + sqrt(2-(w2(t)-13)^2);
y81(t) = 0.13*w2(t) - sqrt(2-(w2(t)-13)^2);

end

figure(1)
plot(WW,PP,w,Psi(:,:))
hold on
plot(w2,y1,'k',w2,y2,'k',w2,y3,'k',w2,y4,'k');
hold on
plot(w2,y5,'k',w2,y6,'k',w2,y7,'k',w2,y8,'k');
title('Compressor one');
xlabel('Mass flow [m^3/s]');
ylabel('Pressure [bar]');
%
figure(2)
plot(WW1,PP,w,Psi(:,:))
hold on
plot(w2,y11,'k',w2,y21,'k',w2,y31,'k',w2,y41,'k');
hold on
plot(w2,y51,'k',w2,y61,'k',w2,y71,'k',w2,y81,'k');
title('Compressor two');
xlabel('Mass flow [m^3/s]');
ylabel('Pressure [bar]');
%
figure(3)
plot(time,WW,time,WWref)
xlabel('Time [s]');
ylabel('Mass flow [m^3/s]');
legend('Flow  Compressor1','Compressor1 reference')
%
figure(4)
plot(time,WW1,time,WW1ref)
xlabel('Time [s]');
ylabel('Mass flow [m^3/s]');
legend('Flow  Compressor2','Compressor2 reference')
%
figure(5)
plot(time,PP,time,P_pref)
xlabel('Time [s]');
ylabel('Pressure [bar]');
legend('Plenum pressure','Reference set point')
%
figure(6)
plot(time,WWtot,time,Wt)
xlabel('Time [s]');
ylabel('Mass flow [m^3/s]');
legend('Total mass flow into plenum','Total mass flow out')
%
figure(7)
plot(time,u_omega1,time,u_omega2)
xlabel('Time [s]');
ylabel('Speed [rps]');
legend('Control moves compressor one','Control moves compressor two')
%
figure(8)
plot(time,u_v)
xlabel('Time [s]');
ylabel('Valve control signal');
legend('Control moves throttle valve')
%

clear WWref WW1ref P_pref


%% 


% w = (0.1:0.1:30)';
% 
% N = length(w);
% % PSI = zeros(N,1);
% PSII = zeros(N,1);
% my1 = zeros(N,1);
% mu = 0.9091;
% omega=omegaR/60;
% 
% 
% for i = 1:N
%     
%   my1(i) = sigma*(1-cot(beta2b)/(rho1*A1*r1)*w(i)/omega);
% %         my1(i) = 0.99;
% %         if (i < 21)
% %         PSII(i) = ((i-21)*0.03)^2+3.6583;
% %         else
%         PSII(i) = (1+(my1(i)*r2^2*omega^2 - ((r1^2)/2)*(omega - alpha * w(i))^2 - kf*w(i)^2)/(cp*T01))^(kappa/(kappa - 1));
%         
% %         end
% end
